# ncurses 6.1 - patch 20180804 - Thomas E. Dickey
#
# ------------------------------------------------------------------------------
#
# Ncurses 6.1 is at
# 	ftp.gnu.org:/pub/gnu
#
# Patches for ncurses 6.1 can be found at
# 	ftp://ftp.invisible-island.net/ncurses/6.1
#	http://invisible-mirror.net/archives/ncurses/6.1 
#
# ------------------------------------------------------------------------------
# ftp://ftp.invisible-island.net/ncurses/6.1/ncurses-6.1-20180804.patch.gz
# patch by Thomas E. Dickey <dickey@invisible-island.net>
# created  Sun Aug  5 01:06:31 UTC 2018
# ------------------------------------------------------------------------------
# NEWS                             |    8 +++++++-
# VERSION                          |    2 +-
# dist.mk                          |    4 ++--
# package/debian-mingw/changelog   |    4 ++--
# package/debian-mingw64/changelog |    4 ++--
# package/debian/changelog         |    4 ++--
# package/mingw-ncurses.nsi        |    4 ++--
# package/mingw-ncurses.spec       |    2 +-
# package/ncurses.spec             |    2 +-
# progs/clear_cmd.c                |    8 ++++----
# 10 files changed, 24 insertions(+), 18 deletions(-)
# ------------------------------------------------------------------------------
Index: NEWS
Prereq:  1.3165 
--- ncurses-6.1-20180728+/NEWS	2018-07-28 23:24:55.000000000 +0000
+++ ncurses-6.1-20180804/NEWS	2018-08-04 16:18:03.000000000 +0000
@@ -25,7 +25,7 @@
 -- sale, use or other dealings in this Software without prior written        --
 -- authorization.                                                            --
 -------------------------------------------------------------------------------
--- $Id: NEWS,v 1.3165 2018/07/28 23:24:55 tom Exp $
+-- $Id: NEWS,v 1.3167 2018/08/04 16:18:03 tom Exp $
 -------------------------------------------------------------------------------
 
 This is a log of changes that ncurses has gone through since Zeyd started
@@ -45,6 +45,12 @@
 Changes through 1.9.9e did not credit all contributions;
 it is not possible to add this information.
 
+20180804
+	+ improve logic for clear with E3 extension, in case the terminal
+	  scrolls content onto its saved-lines before actually clearing
+	  the display, by clearing the saved-lines after clearing the
+	  display (report/patch by Nicholas Marriott).
+
 20180728
 	+ improve documentation regarding feature-test macros in curses.h
 	+ improve documentation regarding the virtual and physical screens.
Index: VERSION
--- ncurses-6.1-20180728+/VERSION	2018-07-28 13:24:09.000000000 +0000
+++ ncurses-6.1-20180804/VERSION	2018-08-04 13:39:57.000000000 +0000
@@ -1 +1 @@
-5:0:10	6.1	20180728
+5:0:10	6.1	20180804
Index: dist.mk
Prereq:  1.1234 
--- ncurses-6.1-20180728+/dist.mk	2018-07-28 13:24:09.000000000 +0000
+++ ncurses-6.1-20180804/dist.mk	2018-08-04 13:39:57.000000000 +0000
@@ -25,7 +25,7 @@
 # use or other dealings in this Software without prior written               #
 # authorization.                                                             #
 ##############################################################################
-# $Id: dist.mk,v 1.1234 2018/07/28 13:24:09 tom Exp $
+# $Id: dist.mk,v 1.1235 2018/08/04 13:39:57 tom Exp $
 # Makefile for creating ncurses distributions.
 #
 # This only needs to be used directly as a makefile by developers, but
@@ -37,7 +37,7 @@
 # These define the major/minor/patch versions of ncurses.
 NCURSES_MAJOR = 6
 NCURSES_MINOR = 1
-NCURSES_PATCH = 20180728
+NCURSES_PATCH = 20180804
 
 # We don't append the patch to the version, since this only applies to releases
 VERSION = $(NCURSES_MAJOR).$(NCURSES_MINOR)
Index: package/debian-mingw/changelog
--- ncurses-6.1-20180728+/package/debian-mingw/changelog	2018-07-28 13:24:09.000000000 +0000
+++ ncurses-6.1-20180804/package/debian-mingw/changelog	2018-08-04 13:39:57.000000000 +0000
@@ -1,8 +1,8 @@
-ncurses6 (6.1+20180728) unstable; urgency=low
+ncurses6 (6.1+20180804) unstable; urgency=low
 
   * latest weekly patch
 
- -- Thomas E. Dickey <dickey@invisible-island.net>  Sat, 28 Jul 2018 09:24:09 -0400
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Sat, 04 Aug 2018 09:39:57 -0400
 
 ncurses6 (5.9-20131005) unstable; urgency=low
 
Index: package/debian-mingw64/changelog
--- ncurses-6.1-20180728+/package/debian-mingw64/changelog	2018-07-28 13:24:09.000000000 +0000
+++ ncurses-6.1-20180804/package/debian-mingw64/changelog	2018-08-04 13:39:57.000000000 +0000
@@ -1,8 +1,8 @@
-ncurses6 (6.1+20180728) unstable; urgency=low
+ncurses6 (6.1+20180804) unstable; urgency=low
 
   * latest weekly patch
 
- -- Thomas E. Dickey <dickey@invisible-island.net>  Sat, 28 Jul 2018 09:24:09 -0400
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Sat, 04 Aug 2018 09:39:57 -0400
 
 ncurses6 (5.9-20131005) unstable; urgency=low
 
Index: package/debian/changelog
--- ncurses-6.1-20180728+/package/debian/changelog	2018-07-28 13:24:09.000000000 +0000
+++ ncurses-6.1-20180804/package/debian/changelog	2018-08-04 13:39:57.000000000 +0000
@@ -1,8 +1,8 @@
-ncurses6 (6.1+20180728) unstable; urgency=low
+ncurses6 (6.1+20180804) unstable; urgency=low
 
   * latest weekly patch
 
- -- Thomas E. Dickey <dickey@invisible-island.net>  Sat, 28 Jul 2018 09:24:09 -0400
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Sat, 04 Aug 2018 09:39:57 -0400
 
 ncurses6 (5.9-20120608) unstable; urgency=low
 
Index: package/mingw-ncurses.nsi
Prereq:  1.281 
--- ncurses-6.1-20180728+/package/mingw-ncurses.nsi	2018-07-28 13:24:09.000000000 +0000
+++ ncurses-6.1-20180804/package/mingw-ncurses.nsi	2018-08-04 13:39:57.000000000 +0000
@@ -1,4 +1,4 @@
-; $Id: mingw-ncurses.nsi,v 1.281 2018/07/28 13:24:09 tom Exp $
+; $Id: mingw-ncurses.nsi,v 1.282 2018/08/04 13:39:57 tom Exp $
 
 ; TODO add examples
 ; TODO bump ABI to 6
@@ -10,7 +10,7 @@
 !define VERSION_MAJOR "6"
 !define VERSION_MINOR "1"
 !define VERSION_YYYY  "2018"
-!define VERSION_MMDD  "0728"
+!define VERSION_MMDD  "0804"
 !define VERSION_PATCH ${VERSION_YYYY}${VERSION_MMDD}
 
 !define MY_ABI   "5"
Index: package/mingw-ncurses.spec
--- ncurses-6.1-20180728+/package/mingw-ncurses.spec	2018-07-28 13:24:09.000000000 +0000
+++ ncurses-6.1-20180804/package/mingw-ncurses.spec	2018-08-04 13:39:57.000000000 +0000
@@ -3,7 +3,7 @@
 Summary: shared libraries for terminal handling
 Name: mingw32-ncurses6
 Version: 6.1
-Release: 20180728
+Release: 20180804
 License: X11
 Group: Development/Libraries
 Source: ncurses-%{version}-%{release}.tgz
Index: package/ncurses.spec
--- ncurses-6.1-20180728+/package/ncurses.spec	2018-07-28 13:24:09.000000000 +0000
+++ ncurses-6.1-20180804/package/ncurses.spec	2018-08-04 13:39:57.000000000 +0000
@@ -1,7 +1,7 @@
 Summary: shared libraries for terminal handling
 Name: ncurses6
 Version: 6.1
-Release: 20180728
+Release: 20180804
 License: X11
 Group: Development/Libraries
 Source: ncurses-%{version}-%{release}.tgz
Index: progs/clear_cmd.c
Prereq:  1.3 
--- ncurses-6.1-20180728+/progs/clear_cmd.c	2017-10-08 00:04:26.000000000 +0000
+++ ncurses-6.1-20180804/progs/clear_cmd.c	2018-08-04 18:43:22.000000000 +0000
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 2016,2017 Free Software Foundation, Inc.                   *
+ * Copyright (c) 2016-2017,2018 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -37,7 +37,7 @@
 #define USE_LIBTINFO
 #include <clear_cmd.h>
 
-MODULE_ID("$Id: clear_cmd.c,v 1.3 2017/10/08 00:04:26 tom Exp $")
+MODULE_ID("$Id: clear_cmd.c,v 1.4 2018/08/04 18:43:22 Nicholas.Marriott Exp $")
 
 static int
 putch(int c)
@@ -48,12 +48,12 @@
 int
 clear_cmd(bool legacy)
 {
+    int retval = tputs(clear_screen, lines > 0 ? lines : 1, putch);
     if (!legacy) {
 	/* Clear the scrollback buffer if possible. */
 	char *E3 = tigetstr("E3");
 	if (E3)
 	    (void) tputs(E3, lines > 0 ? lines : 1, putch);
     }
-
-    return tputs(clear_screen, lines > 0 ? lines : 1, putch);
+    return retval;
 }
